"use strict";
// DropdownInput.tsx
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FieldDropdownInput = void 0;
const React = __importStar(require("react"));
const react_native_paper_1 = require("react-native-paper");
const react_native_paper_dropdown_1 = __importDefault(require("react-native-paper-dropdown"));
const formik_1 = require("formik");
const FieldDropdownInput = ({ name, onChange, title, onBlur, options, ...props }) => {
    const [field, meta, helpers] = (0, formik_1.useField)(name);
    const [showDropDown, setShowDropDown] = React.useState(false);
    const error = meta.touched && meta.error;
    return (React.createElement(React.Fragment, null,
        title && React.createElement(react_native_paper_1.Text, { variant: "labelSmall" }, title),
        React.createElement(react_native_paper_dropdown_1.default, { label: props.placeholder, mode: "outlined", visible: showDropDown, showDropDown: () => setShowDropDown(true), onDismiss: () => setShowDropDown(false), value: field.value, setValue: (value) => {
                helpers.setValue(value);
                onChange?.(value);
            }, list: options }),
        React.createElement(react_native_paper_1.HelperText, { type: "error", visible: !!error }, error)));
};
exports.FieldDropdownInput = FieldDropdownInput;
